diff --git a/net/x25/af_x25.c b/net/x25/af_x25.c
index f937e81e0f501..566e05ec0b46b 100644
--- a/net/x25/af_x25.c
+++ b/net/x25/af_x25.c
@@ -818,6 +818,7 @@ static int x25_connect(struct socket *sock, struct sockaddr *uaddr,
 		x25_neigh_put(x25->neighbour);
 		x25->neighbour = NULL;
 		read_unlock_bh(&x25_list_lock);
+		x25->state = X25_STATE_0;
 	}
 out_put_route:
 	x25_route_put(rt);
